<template>
   <b-container fluid>
       <b-card>
           <b-row>
               <h3 class="card-title">GIAO DỊCH HÔM NAY {{ moment().format('DD/MM/YYYY') }} <a href="#" class="badge badge-primary">LIVE</a></h3>
           </b-row>
    <!-- <vue-good-table
      :columns="columns"
      :rows="sortedPayments"
      styleClass="table table-hover"/> -->
        <b-row>
            <b-col md="3" class="my-1">
                <b-form-group horizontal label="Hiển thị">
                    <b-form-select :options="pageOptions" v-model="perPage" />
                </b-form-group>
            </b-col>
            <b-col md="9"  class="my-1">
                <b-button size="sm" @click.stop="fetchPayments()" class="mr-1 pull-right" align-self="end" variant="primary">
         Refresh
        </b-button>
            </b-col>
        </b-row>
      <b-table   hover 
               :items="sortedPayments" 
               :fields="fields"
               :current-page="currentPage"
               :per-page="perPage">
                   <template slot="amount" slot-scope="data">
                       <span v-if="data.item.salesman_paid == 0 || data.item.salesman_paid == data.value">
                            {{ data.value }} 
                        </span>
                        <span v-else>
                           {{ data.item.salesman_paid }} / {{ data.value }}
                        </span>
      
    </template>
          <span slot="status_label" slot-scope="data" v-html="data.value"></span>

        <template slot="actions" slot-scope="row">
        <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->
        
       <b-button size="sm" @click.stop="showConfirmPaymentForm(row.item, row.index, $event.target)" class="mr-1" variant="primary" v-if="row.item.status<3">
          Xác nhận
        </b-button>
        <b-button size="md" class="mr-1" variant="info"  v-else>
            <span v-if="row.item.payments_to_company_details.length ==1"> {{ row.item.payments_to_company_details[0].reference_code }}</span>
            <span v-else>
            LỊCH SỬ GIAO DỊCH
            </span>
        
        </b-button>
      </template>       
      </b-table>
          <b-row>
      <b-col md="6" class="my-1">
        <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
      </b-col>
    </b-row>
</b-card>
<confirm-payment-modal ref="confirmPaymentModalRef" :payment="selectedPayment"></confirm-payment-modal>
   </b-container>

</template>

<script>
import { alerts } from '../../utils';
import { socket, http } from '../../services'
import ConfirmPaymentModal from './ConfirmPaymentModal'

export default {
    name: 'live-payment-table',
    components: { ConfirmPaymentModal },
    data() {
        return {
            fields: [{
                    key: 'id',
                    label: 'Mã DG',
                    sortable: true
                },
                {
                    key: 'agency.name',
                    label: 'Tên đại lý',
                    sortable: true
                },
                {
                    key: 'salesman.name',
                    label: 'Nhân viên GD',
                    sortable: true,
 
                },
                {
                    key: 'amount',
                    label: 'Số tiền',
                    sortable: true,
                },
                {
                    key: 'created_at',
                    label: 'Ngày tạo',
                    sortable: true,
                    formatter: (value) => {
                        return moment(value).format('DD/MM/YYYY HH:mm:ss')
                    }

                },
                {
                    key: 'status_label',
                    label: 'Trạng thái',
                    sortable: true,

                },

                {
                    key: 'actions',
                    label: 'Xác nhận nộp tiền'
                }
            ],
            payments: [

            ],
            currentPage: 1,
            perPage: 5,
            totalRows: 0,
            pageOptions: [5, 10, 15],
            selectedPayment: null,
        };
    },
    created() { 
        this.fetchPayments();
        this.listenForChanges();
    },
    methods: {
        fetchPayments() {
            http.get('/payment/live',(response) => {
                this.payments = response.data;
                this.totalRows = response.data.length;
            })
        },
        moment: function () {
            return moment();
        },
        /**
         * Post a request to confirm payment
         * @param {int} payment_id
         * @param {string} reference_code
         * 
         */
        confirmPayment(payment_id, reference_code) {
            http.post('/payment/confirm', {
                    id: payment_id,
                    reference_code: reference_code
                },(response) => {
                    return response;
                    // console.log(response.data.status);
                    // if (response.data.status) {
                    //    alerts.success(response.data.msg);
                    // } else {
                    //     alerts.warning(response.data.msg);
                    // }
                })
        },
        listenForChanges() {
            socket.echo.private('admin')
                .listen('PaymentCreated', (e) => {
                        this.payments.push(e.payment)
                })
                .listen('PaymentUpdated',(e) => {
                 //   console.log(e.payment.salesman_paid);
                    var payment = this.payments.find((payment) => payment.id === e.payment.id);
                    // check if payment exist on table
                    if (payment) {
                        
                        var index = this.payments.indexOf(payment);
                        //console.log(payment);
                        this.payments[index].salesman_paid = e.payment.salesman_paid;
                        this.payments[index].status = e.payment.status;
                        this.payments[index].status_label = e.payment.status_label;
                        this.payments[index].payments_to_company_details = e.payment.payments_to_company_details;
                       // console.log(this.payments[index]);
                    }
                    // if not, add 'em
                    else {
                        this.payments.push(e.payment)
                    }
                })
        },
        showConfirmPaymentForm(item, index, button) {
            this.selectedPayment = item;
            this.$refs.confirmPaymentModalRef.showModal();
            //alerts.ajaxRequest('Mã giấý tờ (optional)',item.id,this.confirmPayment);
            // swal("Mã giấy tờ (Optional)):", {
            //         content: "input",
            //     })
            //     .then((value) => {
            //         this.confirmPayment(item.id, value);

            //     });
            // this.modalInfo.title = `Row index: ${index}`
            // this.modalInfo.agency = item.agency;
            // this.$root.$emit('bv::show::modal', 'modalInfo', button)
        },
        

    },
    computed: {
        sortedPayments() {
            return this.payments.sort((a, b) => a.status - b.status || new Date(b.created_at) - new Date(a.created_at))
        }
    }
};
</script>